﻿using MVVMDataGridBinding.Command;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace MVVMDataGridBinding.ViewModel
{
    internal class MainViewModel : BaseViewModel
    {
        private DataTable _resultTable;

        private ICommand _updateCommand;

        public DataTable ResultTable
        {
            get { return _resultTable; }
            set
            {
                _resultTable = value;
                OnPropertyChanged(nameof(ResultTable));
            }
        }

        public ICommand UpdateCommand
        {
            get { return _updateCommand ?? (_updateCommand = new DelegateCommand(UpdateData)); }
        }

        public MainViewModel()
        {
            this.ResultTable = GetSampleData();
        }

        private DataTable GetSampleData()
        {
            DataTable table = new DataTable();
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Age", typeof(int));

            table.Rows.Add("Agent1", 21);
            table.Rows.Add("Agent2", 22);
            table.Rows.Add("Agent3", 23);
            table.Rows.Add("Agent4", 24);

            return table;
        }

        private void UpdateData()
        {
            this.ResultTable.Columns.Clear();
            this.ResultTable.Rows.Clear();

            DataTable table = new DataTable();
            table.Columns.Add("Call Sign", typeof(string));
            table.Columns.Add("Kill Score", typeof(int));

            table.Rows.Add("Ghost", 2);
            table.Rows.Add("Holyness", 4);
            table.Rows.Add("Hyde", 1);
            table.Rows.Add("Magellan", 5);
            table.Rows.Add("Inch", 8);

            this.ResultTable = table;
        }
    }
}
